select
  an.numero
  , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
  ,(case sp.cprodutiva when 3 then 'Seca' when 4 then 'Lactante' else null end) as status_produtivo
  , ma.data
  , (case when ((select max(lac.dtinicio) from lactacao lac where lac.cdanimal = ma.cdanimal and lac.dtinicio <= ma.data and
        ((lac.dtfim is null) or (lac.dtfim > ma.data))) is not null) then
            (ma.data - (select max(lac.dtinicio) from lactacao lac where lac.cdanimal = ma.cdanimal and lac.dtinicio <= ma.data and
        ((lac.dtfim is null) or (lac.dtfim > ma.data)))) else null end) as del
  , ma.ordenha
  , (case ma.ad
        when 0 then '1 (Grumos)'
        when 1 then '2 (Glndula inchada)'
        when 2 then '3 (Sistmico: grumos, glndula inchada, febre)'
        when 3 then '0 (Sem grumos)'
        else '' end) as ad
  , (case ma.ae
        when 0 then '1 (Grumos)'
        when 1 then '2 (Glndula inchada)'
        when 2 then '3 (Sistmico: grumos, glndula inchada, febre)'
        when 3 then '0 (Sem grumos)'
        else '' end) as ae
  , (case ma.pd
        when 0 then '1 (Grumos)'
        when 1 then '2 (Glndula inchada)'
        when 2 then '3 (Sistmico: grumos, glndula inchada, febre)'
        when 3 then '0 (Sem grumos)'
        else '' end) as pd
  , (case ma.pe
        when 0 then '1 (Grumos)'
        when 1 then '2 (Glndula inchada)'
        when 2 then '3 (Sistmico: grumos, glndula inchada, febre)'
        when 3 then '0 (Sem grumos)'
        else '' end) as pe
  , mic1.nome as mic_1
  , mic2.nome as mic_2
  , tb.nome as tratamento
  , (case ma.via
        when 0 then 'IMA (Intra-mamrio)'
        when 1 then 'IMU (Intra-muscular)'
        when 2 then 'Todas'
        when 3 then 'IV (Intra-venoso)'
        else null end) as via
  , ma.observacao as observacao_mastite
from
  animal an
  join mamite ma on ma.cdanimal = an.cdanimal
  left join microorganismo mic1 on mic1.cdmicroorganismo = ma.cdmicroorganismo1
  left join microorganismo mic2 on mic2.cdmicroorganismo = ma.cdmicroorganismo2
  left join tratamentobase tb on tb.cdtratamentobase = ma.cdtratamentobase
  join sp_categoriaanimal(current_date, '') sp on sp.animal = an.cdanimal
where
  an.dtbaixa is null
  and ma.data between (select first 1 dtinicio from lactacao where cdanimal = an.cdanimal order by dtinicio desc)
  and (coalesce((select first 1 dtfim from lactacao where cdanimal = an.cdanimal order by dtinicio desc) , '2200-12-31'))
order by
  an.numordenado, ma.data
